
-- pgsqlds2_create_db.sql: DVD Store Database Version 2.1 Build Script - Postgres version
-- Copyright (C) 2011 Vmware, Inc. 
-- Last updated 2/13/11

CREATE UNIQUE INDEX IX_CUST_USERNAME ON CUSTOMERS 
  (
  USERNAME
  );

CREATE UNIQUE INDEX IX_CUST_USER_PASSWORD ON CUSTOMERS 
  (
  USERNAME,
  PASSWORD
  );

CREATE INDEX IX_CUST_HIST_CUSTOMERID ON CUST_HIST
  (
  CUSTOMERID
  );

ALTER TABLE CUST_HIST
  ADD CONSTRAINT FK_CUST_HIST_CUSTOMERID FOREIGN KEY (CUSTOMERID)
  REFERENCES CUSTOMERS (CUSTOMERID)
  ON DELETE CASCADE
  ;

CREATE INDEX IX_ORDER_CUSTID ON ORDERS
  (
  CUSTOMERID
  );

ALTER TABLE ORDERS 
  ADD CONSTRAINT FK_CUSTOMERID FOREIGN KEY (CUSTOMERID)
  REFERENCES CUSTOMERS (CUSTOMERID)
  ON DELETE SET NULL
  ;

CREATE UNIQUE INDEX IX_ORDERLINES_ORDERID ON ORDERLINES
  (
  ORDERID, ORDERLINEID
  );

ALTER TABLE ORDERLINES
  ADD CONSTRAINT FK_ORDERID FOREIGN KEY (ORDERID)
  REFERENCES ORDERS (ORDERID)
  ON DELETE CASCADE
  ;

CREATE INDEX IX_PROD_ACTOR ON PRODUCTS 
USING GIN
  (
  to_tsvector('simple',ACTOR)
  );

CREATE INDEX IX_PROD_CATEGORY ON PRODUCTS 
  (
  CATEGORY
  );

CREATE INDEX IX_PROD_TITLE ON PRODUCTS 
USING GIN
  (
   to_tsvector('simple',TITLE)
  );

CREATE INDEX IX_PROD_SPECIAL ON PRODUCTS 
  (
  SPECIAL
  );

CREATE INDEX IX_PROD_CAT_SPECIAL ON PRODUCTS 
  (
  CATEGORY,
  SPECIAL
  );
